# JXYS网站设计规范标准

## 官网类

### 设计思路
```
1，一般采用响应式设计，适配PC端和移动端
2，一般采用简洁的布局，突出重点内容
3，一般采用高质量的图片和视频，提升用户体验
4，一般采用简洁的字体和颜色，提升阅读体验
5，一般采用简洁的导航和菜单，提升操作体验
6，一般采用简洁的按钮和表单，提升操作体验
7，一般采用简洁的图标和动画，提升视觉体验
8，一般采用简洁的提示和反馈，提升用户体验
9，一般采用简洁的加载和进度条，提升用户体验
10，一般采用简洁的搜索和筛选，提升用户体验
```

### 模块设计
```
1，页头(头部导航)：包括网站logo、首页跳转、公司介绍、产品介绍、技术支持、电子商城(如果有需要)、联系我们、页尾(尾部导航) 等通用模块
2，首页：包括轮播图、新闻动态、产品展示、合作伙伴、联系我们、页尾(尾部导航) 等模块
3，公司介绍：包括公司简介、企业文化、组织架构、荣誉资质 等模块
4，产品介绍：包括产品分类、产品详情、产品对比、产品下载 等模块
4，技术支持：包括技术文档、常见问题、在线客服 等模块
5，电子商城(如果有需要)：包括商品分类、商品详情、购物车、订单管理 等模块
6，联系我们：包括联系方式、在线留言、地图定位 等模块
7，页尾(尾部导航)：包括版权信息、友情链接、网站地图 等模块
```

### 设计技术
```
html+css+js
如有后台服务需求，可使用express
```